<?php
// where file data is stored
define('FD','./files/');

// where file info is stored
define('FI','./fileinfo/');

function parseFileInfo($fi) {
	$fh = fopen($fi,'r');
	$fname = trim(fgets($fh));
	fclose($fh);
	return array($fname);
}

if (empty($_GET['sha1'])) die("sha1 is required to download file");
$sha1 = trim($_GET['sha1']);

if (!file_exists(FD.$sha1)) die("no file found for this sha1 hash");
if (!is_readable(FD.$sha1)) die("cannot read file data!");
$fsize = filesize(FD.$sha1);
$fctime = filectime(FD.$sha1);
if (!is_readable(FI.$sha1)) die("cannot read file info!");
list($fname) = parseFileInfo(FI.$sha1);
$fmime = mime_content_type(FD.$sha1);

// Use browser cached version
$imstime = isset($_SERVER["HTTP_IF_MODIFIED_SINCE"]) ? (int)strtotime(preg_replace('/;.*$/','',$_SERVER["HTTP_IF_MODIFIED_SINCE"])) : 0;
if ($fctime <= $imstime) die(header("HTTP/1.0 304 Not Modified",1,304));

// Redirect to pure http download
// die(header('Location: files/$sha1'),1,302);

// or .. push the file thru PHP
header('Content-Length: '.$fsize);
header('Content-Type: '.$fmime);
header('Last-Modified: '.gmdate('D, d M Y H:i:s',$fctime).' GMT');
header('Content-Disposition: attachment; filename="'.$fname.'"');
readfile(FD.$sha1);
