<?php

// where file data is stored
define('FD','./files/');

// where file info is stored
define('FI','./fileinfo/');

function parseFileInfo($fi) {
	$fh = fopen($fi,'r');
	$fname = trim(fgets($fh));
	fclose($fh);
	return array($fname);
}

function niceSize($b) {
	$si = array(" bytes", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
	return $b>1024 ? round($b/pow(1024, ($i = floor(log($b, 1024)))), 2) . $si[$i]." ($b bytes)" : $b.' bytes';
}

if (empty($_GET['sha1'])) die("sha1 is required to get file info");
$sha1 = trim($_GET['sha1']);

if (!file_exists(FD.$sha1)) die("no file found for this sha1 hash");
if (!is_readable(FD.$sha1)) die("cannot read file data!");
$fsize = niceSize(filesize(FD.$sha1));
$fctime = gmdate("F d Y H:i:s",filectime(FD.$sha1))." GMT";
if (!is_readable(FI.$sha1)) die("cannot read file info!");
list($fname) = parseFileInfo(FI.$sha1);

readfile('head.html');

if ($fname) echo "<h1><a href=\"/$sha1\">$fname</a></h1>";
// if ($fname) echo "<h1><a href=\"download.php?sha1=$sha1\">$fname</a></h1>";
echo "<ul>";
echo "<li>SIZE: $fsize</li>";
echo "<li>TIME: $fctime</li>";
echo "<li>SHA1: $sha1</li>";
@ob_flush();@flush(); // big files might be take a while md5
if ($md5=md5_file(FD.$sha1)) echo "<li>MD5: $md5</li>";
echo "<ul>";

readfile('foot.html');
